;-----------------------------
; Output : T - presence bit
;-----------------------------
OWReset:
	cbi		w1Port,w1	; 
	sbi		w1Dir,w1	; "0"  
	ldi		w1del,48	;480 (470)
	rcall	Del_10		;
	cbi		w1Dir,w1	; "1"  
	ldi		w1del,7		;70 (70)
	rcall	Del_10		;
	set
	sbis	w1Pin,w1
	clt
	ldi		w1del,24	;240 (240)
	rcall	Del_10		;
	ret
;-----------------------------
; Input : r16 - byte to write
;-----------------------------
OWWriteByte:
	ldi		w1cnt,8
OWWriteLoop:	
	ror		w1rdbuf
;	rcall	OWWriteBit	
;-----------------------------
; Input : C - bit to write
;-----------------------------
OWWriteBit:
	brcs	OWWriteOne
OWWriteZero:
	sbi		w1Dir, w1
		ldi		w1del,6		;60 (120)
		rcall	Del_10		;
	cbi		w1Dir, w1	
		rjmp	OWWriteEnd
OWWriteOne:
	sbi		w1Dir, w1
		rjmp	PC+1		; 1us(1,25)
		rjmp	PC+1		;*4=5us
		rjmp	PC+1
		rjmp	PC+1
	cbi		w1Dir, w1
OWWriteEnd:
		ldi		w1del,6		;60 (60)
		rcall	Del_10		;
;	ret
	dec		w1cnt
	brne	OWWriteLoop
	ret
;-------------------------------
; Output : r16 - byte from slave
;-------------------------------
OWReadByte:
	ldi		w1cnt,8
OWReadLoop:
;	rcall	OWReadBit
;-----------------------------
; Output : C - bit from slave
;-----------------------------
OWReadBit:
		sbi		w1Dir, w1
rjmp	PC+1			; 1us(1,25)
rjmp	PC+1			; 1us(1,25)
rjmp	PC+1			; 1us(1,25)
rjmp	PC+1			; 1us(1,25)
		cbi		w1Dir, w1
rjmp	PC+1			; 5us
rjmp	PC+1
rjmp	PC+1
rjmp	PC+1
		lsr		w1rdbuf		; 
		sbic	w1Pin,w1
		sbr		w1rdbuf,$80		; 1 (  7  "1")
		ldi		w1del,5		;50 (50)
		rcall	Del_10		;
OWReadBitEnd:
;	ret
	dec		w1cnt
	brne	OWReadLoop
	ret
;-------------------------------
Del_10_loop:	; 10 
nop	;+7 
rjmp	PC+1
rjmp	PC+1
rjmp	PC+1
Wait4xCycles:
Del_10:			;   
rjmp	PC+1
rjmp	PC+1
rjmp	PC+1
	dec		w1del
	brne	Del_10_loop			; 
	ret
