;**********  Variables  ************* 
.equ	osc	=	1600000	;   1.6MHz
.equ	SendDel	=	255;220		;    HT1611
.equ	DelConst	=	0
;**************           *****************
.equ	w1Port	=	PORTB
.equ	w1Dir	=	DDRB
.equ	w1Pin	=	PINB
.equ	w1		=	PB0	;  '0'  B ( 1wire)
.equ	dout	=	PB4		;    HT1611
.equ	clk		=	PB3		;    HT1611
;**************        *****************
; ************* Low *****************
.def	Command_0	= R5;21			;    
.def	Command_1	= R6
.def	Command_2	= R7
.def	Command_3	= R8
.def	Command_4	= R9
;.def	Command_5	= R10
;.def	Command_6	= R11
;.def	Command_7	= R12
;.def	Command_8	= R13
;.def	Command_9	= R14

.def	sc0	=	r10
.def	sc1	=	r11
.def	sc2	=	r12
.def	sc3	=	r13
.def	sc4	=	r14
.def	TempSreg	=	R15		;  SREG
; ************* High ****************
.def	temp 		=	r16	;  

.def	SendCnt		=	R20	;    
.def	SendDelReg	=	R21	;     

.def	w1rdbuf	=	r22	;  (  )
.def	w1cnt	=	r23	; 
;.def	w1takt	=	r24	; 
.def	w1del	=	r25	;   
; *************   ****************
; ************    **************
;.def			=	r26	; XL	
;.def			=	r27	; XH
;.def			=	r28	; YL	
;.def			=	r29	; YH
.def	indL	=	r30	; ZL	  
.def	indH	=	r31	; ZH	    
;********  End Variables  ***********
.macro	RolCmd
	rol	Command_0	;   
	rol	Command_1	;
	rol	Command_2
	rol	Command_3
	rol	Command_4
.endm
.macro	ClrCmd
	clr	Command_0
	clr	Command_1
	clr	Command_2
	clr	Command_3
	clr	Command_4
.endm
.macro	ClrSc
	clr	sc0
	clr	sc1
	clr	sc2
	clr	sc3
	clr	sc4
.endm
.macro	StCmd
	mov	sc0,Command_0
	mov	sc1,Command_1
	mov	sc2,Command_2
	mov	sc3,Command_3
	mov	sc4,Command_4
.endm
.macro	RolSc
	lsl	sc0
	rol	sc1
	rol	sc2
	rol	sc3
	rol	sc4
.endm
